using SchoolManagementSidekick;
using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Threading;
using System.Threading.Tasks;

namespace SchoolManagementSidekick
{
    public interface IPersonService : IEntityServiceBase<Person, int>
    {
        public IQueryable<TEntity> GetFiltered<TEntity>(Expression<Func<TEntity, bool>> filter, CancellationToken token = default)
            where TEntity : class;

        public Task<IEnumerable<Person>> FilterByFirstName(string firstName, CancellationToken token = default);
        Task<int?> GetHighestGradedCourseForStudent(int studentId);
        Task<decimal> InsertPersonAsync(string? lastName, string? firstName, DateTime? hireDate, DateTime? enrollmentDate, string? discriminator, CancellationToken ct);
    }
}
