using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using SchoolManagementSidekick;
using System;
using System.Collections.Generic;

namespace SchoolManagementSidekick
{
    public class InstructorOfficesEntityTypeConfiguration : IEntityTypeConfiguration<InstructorOffices>
    {
        public void Configure(EntityTypeBuilder<InstructorOffices> builder)
        {
            builder
                .Property(x => x.InstructorId)
                .HasColumnName("InstructorId")
                .HasPrecision(10, 0);

            builder
                .Property(x => x.FirstName)
                .HasColumnName("FirstName")
                .IsUnicode(true);

            builder
                .Property(x => x.LastName)
                .HasColumnName("LastName")
                .IsUnicode(true);

            builder
                .Property(x => x.Location)
                .HasColumnName("Location")
                .IsUnicode(true);

            builder
                .HasNoKey()
                .ToView("InstructorOffices", schema: "dbo");
        }
    }
}
