using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using SchoolManagementSidekick;
using System;
using System.Collections.Generic;

namespace SchoolManagementSidekick
{
    public class PersonEntityTypeConfiguration : IEntityTypeConfiguration<Person>
    {
        public void Configure(EntityTypeBuilder<Person> builder)
        {
            builder
                .HasKey(x => x.PersonId);

            builder
                .Property(x => x.PersonId)
                .HasColumnName("PersonID")
                .HasPrecision(10, 0);

            builder
                .Property(x => x.LastName)
                .HasColumnName("LastName")
                .IsUnicode(true);

            builder
                .Property(x => x.FirstName)
                .HasColumnName("FirstName")
                .IsUnicode(true);

            builder
                .Property(x => x.HireDate)
                .HasColumnName("HireDate")
                .HasColumnType("datetime");

            builder
                .Property(x => x.EnrollmentDate)
                .HasColumnName("EnrollmentDate")
                .HasColumnType("datetime");

            builder
                .Property(x => x.Discriminator)
                .HasColumnName("Discriminator")
                .IsUnicode(true);

            builder
                .ToTable("Person", "dbo");
        }
    }
}
